<template>
  <div id="blankContainer" class="container invisible" />
  <div v-if="IsShowBanner" class="w-full px-0 pt-6">
    <div
      class="container mx-auto banner-style-02 !max-w-full !w-full flex justify-center"
    >
      <Carousel
        id="overflowBanner"
        ref="overflowBannerRef"
        class="h-[288px]"
        :items-to-show="3"
        :style="`min-width: calc(((var(${APP_CONTAINER_KEY}) + 0.02px) * 3) + 89.99px)`"
        :snap-align="center"
        :autoplay="3000"
        wrap-around
        :mouse-drag="false"
        @slide-end="onSlideEnd"
      >
        <Slide
          v-for="(item, index) in allowCompany
            ? sortedBanner
            : themeBannerForDisplay"
          :key="`aa-${index}`"
          class="h-[288px]"
        >
          <div class="h-full w-full px-3">
            <nuxt-link :to="item.HyperLink" :id="ID.LOBBY_BANNER[item.HtmlId]">
              <div
                class="img-carousel-wrapper relative rounded-2xl overflow-hidden w-full h-full bg-cover bg-center pointer-events-none"
                :style="{
                  backgroundImage: `url(${item.ImagePath})`,
                }"
              ></div>
            </nuxt-link>
          </div>
        </Slide>
        <template #addons>
          <div class="carousel__pagination-wrapper">
            <Pagination />
          </div>
        </template>
      </Carousel>
    </div>
  </div>
</template>
<script lang="ts" setup>
import _ from "lodash";
import { Carousel, Pagination, Slide } from "vue3-carousel";

import "vue3-carousel/dist/carousel.css";
import { store } from "~~/store";
import { ThemePropertiesFromApiDto } from "~~/models/companyThemePropertiesRespone";
import commonHelper from "@/utils/commonHelper";

const props = defineProps({
  activedTab: {
    type: String,
    default: "",
  },
  height: {
    type: String,
    default: "auto",
  },
  bannerKeys: {
    type: Object as PropType<Record<string, string>>,
    required: true,
  },
});

const actived = computed(() => _.toLower(props.activedTab));
const themeProperties =
  store.state.companyThemePropertiesFromApi.ThemeProperties;
const bannerKey = computed(
  () => props.bannerKeys[actived.value] ?? props.bannerKeys.home
);
const themeBannerForDisplay: Ref<Array<ThemePropertiesFromApiDto>> = ref(
  themePropertyHelper.getMultipleThemesProperties(
    themeProperties,
    bannerKey.value
  )
);
if (actived.value === "sports") {
  themeBannerForDisplay.value = _.filter(
    themeBannerForDisplay.value,
    (theme) => !_.includes(theme.HtmlId, "virtual_")
  );
}
const componentKey = ref(1);
const getBanners = () => {
  const banners = themePropertyHelper.getMultipleThemesProperties(
    themeProperties,
    bannerKey.value
  );
  themeBannerForDisplay.value = _.sortBy(banners, (banner) => {
    const htmlidSplit = banner.HtmlId.split("_");
    const bannerNumber = parseInt(htmlidSplit[htmlidSplit.length - 1]);
    return bannerNumber;
  });

  if (actived.value === "sports") {
    themeBannerForDisplay.value = _.filter(
      themeBannerForDisplay.value,
      (theme) => !_.includes(theme.HtmlId, "virtual_")
    );
  }
  componentKey.value += 1;
};

watch(props, () => {
  getBanners();
});
const resizing = ref();
setInterval(() => {
  resizing.value = window.innerWidth;
}, 500);
const isBannerEnabled = computed(
  (): boolean => themeBannerForDisplay.value.length !== 0
);
const keyForMap: Record<string, string> = {
  home: "home_page_banner_style",
  sports: "sports_page_banner_style",
  livecasino: "live_casino_page_banner_style",
  games: "games_page_banner_style",
  virtualsports: "virtual_sports_page_banner_style",
  cockfight: "cockfight_page_banner_style",
  promotion: "promotion_page_banner_style",
  lottery: "lottery_page_banner_style",
  poker: "poker_page_banner_style",
};
const allBannerPageStyle = themePropertyHelper
  .getAllMultipleThemesProperties(themeProperties, "_page_banner_style")
  .filter((v) => !v.IsHidden);
const pageStyleProperty = computed(() =>
  allBannerPageStyle.find((item) => item.HtmlId === keyForMap[actived.value])
);

const sortedBanner = computed(() => {
  const hasResorcekeyValue = themeBannerForDisplay.value.some(
    (item) => item.ResourceKey
  );
  if (hasResorcekeyValue && allowCompany.value) {
    return _.sortBy(
      _.cloneDeep(themeBannerForDisplay.value).filter(
        (item) => item.Text === "shown"
      ),
      (prop: ThemePropertiesFromApiDto) => {
        if (prop.ResourceKey) {
          return Number(prop.ResourceKey);
        }
        return 999;
      }
    );
  }
  return themeBannerForDisplay.value;
});
const { allowCompany } = commonHelper;

const IsShowBanner = computed(() => {
  if (allowCompany.value)
    return (
      (!pageStyleProperty.value?.IsHidden ?? false) &&
      sortedBanner.value?.length > 0
    );
  return isBannerEnabled.value;
});
const APP_CONTAINER_KEY = "--app-container-width";
const getContainerWidth = () => {
  nextTick(() => {
    const el: Element | null = document.getElementById("blankContainer");
    if (el) {
      const width = el.clientWidth;
      document.documentElement.style.setProperty(
        APP_CONTAINER_KEY,
        `${width}px`
      );
    }
  });
};
const clearWindowResizeEventListener = () => {
  window.removeEventListener("resize", getContainerWidth);
};
const addWindowResizeEventListener = () => {
  clearWindowResizeEventListener();
  window.addEventListener("resize", getContainerWidth);
};
const overflowBannerRef = ref();
const onSlideEnd = ({
  currentSlideIndex = 0,
  prevSlideIndex = 0,
  slidesCount = 0,
}) => {
  const el = document.getElementById("overflowBanner");
  if (!el) return;
  const isNext = currentSlideIndex > prevSlideIndex;
  nextTick(() => {
    const viewportEl = el.getElementsByClassName("carousel__viewport")[0];
    if (!viewportEl) return;
    let shakingClass = isNext ? "shake-animation" : "shake-animation-prev";
    if (prevSlideIndex === slidesCount - 1 && currentSlideIndex === 0) {
      shakingClass = "shake-animation";
    }
    if (prevSlideIndex === 0 && currentSlideIndex === slidesCount - 1) {
      shakingClass = "shake-animation-prev";
    }
    viewportEl.classList.add(shakingClass);
    setTimeout(() => {
      viewportEl.classList.remove(shakingClass);
    }, 450);
  });
};
onMounted(() => {
  document.documentElement.style.setProperty(APP_CONTAINER_KEY, "1200px");
  addWindowResizeEventListener();
  getContainerWidth();
  getBanners();
});
onUnmounted(() => {
  clearWindowResizeEventListener();
});
</script>

<style lang="scss">
.shake-animation {
  animation: shakeX 400ms ease;
  will-change: transform;
}

.shake-animation-prev {
  animation: shakePrevX 400ms ease;
  will-change: transform;
}

@keyframes shakeX {
  0% {
    transform: translateX(-28px);
  }
  100% {
    transform: translateX(0px);
  }
}

@keyframes shakePrevX {
  0% {
    transform: translateX(28px);
  }
  100% {
    transform: translateX(0);
  }
}

.banner-style-02 {
  .carousel {
    .carousel__slide {
      &:not(.carousel__slide--active) {
        .img-carousel-wrapper {
          &::before {
            content: "";
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            z-index: 99;
            background: var(--background2);
            opacity: 0.8;
            mix-blend-mode: color;
          }
        }
      }
    }

    .carousel__pagination-wrapper {
      position: absolute;
      width: 100%;
      bottom: 16px;
      display: flex;
      justify-content: center;

      .carousel__pagination {
        position: relative;
        padding: 8px 16px;
        gap: 4px;

        &::before {
          content: "";
          position: absolute;
          top: 0;
          width: 100%;
          height: 100%;
          background: var(--background5);
          opacity: 0.5;
          border-radius: 16px;
          z-index: 0;
        }

        .carousel__pagination-item {
          z-index: 2;
        }

        .carousel__pagination-button {
          width: 16px;
          height: 16px;
          border-radius: 50%;
          padding: 0;
          display: flex;
          align-items: center;
          justify-content: center;
          border-width: 2px;
          border-style: solid;
          border-color: transparent;
          transition: border-color 0.3s ease-in-out;

          &:after {
            content: "";
            transition: opacity 0.3s ease-in-out;
            width: 8px;
            height: 8px;
            background: var(--text5);
            border-radius: 50%;
            opacity: 0;
          }
          &.carousel__pagination-button--active {
            border-color: var(--primary);
          }

          &:not(.carousel__pagination-button--active):after {
            content: "";
            opacity: 1;
          }
        }
      }
    }
  }

  .img-container {
    border-radius: 16px !important;
    width: 1200px !important;
    height: 288px !important;
    .blur-background {
      filter: none !important;
      border-radius: 16px !important;
    }
  }
}
</style>

<style scoped>
.swiper {
  width: 100%;
  height: 100%;
}

.swiper-slide {
  width: 100%;
}

.swiper-slide-prev,
.swiper-slide-next {
  filter: grayscale(80%);
  opacity: 0.8;
}

.swiper-slide img {
  overflow: hidden;
  width: 100%;
  height: 100%;
  object-fit: cover;
  border-radius: 16px;
}
@keyframes slide {
  0% {
    transform: translateX(0);
  }

  50% {
    transform: translateX(-15px);
  }

  100% {
    transform: translateX(0);
  }
}
</style>
